unit Dbpanel;

interface

uses wintypes, winprocs,

     sysutils, classes, controls, menus, graphics, forms, stdctrls, extctrls,

     db, dbtables, dbctrls;


Const maxfields = 30;
      version   = '0.9.9';

type  tdbpanel = class;

      tdbpanelDatalink = class(Tdatalink)
          Fdbpanel: tdbpanel;
          function    GetFields(I: Integer): TField;
        public
          constructor Create(Apanel: Tdbpanel);
          destructor  Destroy; override;
          property    Fields[I: Integer]: TField read GetFields;
        protected
          procedure   ActiveChanged; override;
          procedure   DataSetChanged; override;
     end;

      tdbpanel = class(tCustompanel)
        private
          fpanfields     : integer;
          fdatalink      : tdbpanelDatalink;
          flinkaktiv     : boolean;
          ftlblst        : array[0..maxfields] of tlabel;
          ftetlst        : array[0..maxfields] of tdbedit;
          fmaxwidth      : integer;
          foptimalheight : integer;
          faliasliste    : tstringlist;

          function    GetDataSource: TDataSource;
          procedure   SetDataSource(Value: TDataSource);
          procedure   buildpanel;
          procedure   cleanpanel;
          procedure   DataChanged;

          procedure   SetBorderWidth(Value: TBorderWidth);
          function    GetBorderWidth:TBorderWidth;
        protected
          procedure   LinkActive(Value: Boolean); virtual;
          procedure   Resize; override;
        public
          constructor Create(AOwner: TComponent); override;
          destructor  Destroy; override;

        published
          {neue Properties}
          property    OptimalHeight:integer read foptimalheight write foptimalheight;
          {gibt die "optimale" Hhe an, d.h. die minimale Hhe, mit der das Panel
           noch einigermaen ertrglich aussieht.}

          property    DataSource: TDataSource read GetDataSource write SetDataSource;
          {Verknpfung zur Datenquelle}

          property    BorderWidth: TBorderWidth read GetBorderWidth write SetBorderWidth;
          {Wie in TPanel, bentigt nur fr Reaktionen}

          property    AliasList:Tstringlist read faliasliste write faliasliste;
          {Kann eine Liste von "<dbfeldname>;<Labeltext>" enthalten, durch die dann
           nicht mehr die Datenbankfeldnamen als Label sondern ein neuer Labeltext
           dargestellt wird}

          {zu bernehmende Properties}
          property Align;
          property Alignment;
          property BevelInner;
          property BevelOuter;
          property BevelWidth;
          property BorderStyle;
          property DragCursor;
          property DragMode;
          property Enabled;
          property Color;
          property Ctl3D;
          property Font;
          property Locked;
          property ParentColor;
          property ParentCtl3D;
          property ParentFont;
          property ParentShowHint;
          property PopupMenu;
          property ShowHint;
          property TabOrder;
          property TabStop;
          property Visible;
          property OnClick;
          property OnDblClick;
          property OnDragDrop;
          property OnDragOver;
          property OnEndDrag;
          property OnEnter;
          property OnExit;
          property OnMouseDown;
          property OnMouseMove;
          property OnMouseUp;
          property OnResize;
      end;

(********************************************************************************************)
(********************************************************************************************)
procedure register;

implementation


(********************************************************************************************)
(********************************************************************************************)
procedure register;
begin
  RegisterComponents('Holgis',[tdbpanel]);
end;

end.
